package ss2011.se.dp;

import static org.junit.Assert.*;

import java.io.File;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

import ss2011.se.dp.filesystem.AbstractFile;
import ss2011.se.dp.filesystem.Directory;
import ss2011.se.dp.filesystem.FilesystemFactory;
import ss2011.se.dp.filesystem.RegularFile;
import ss2011.se.dp.visitors.CountFilesVisitor;
import ss2011.se.dp.visitors.RegularExpressionVisitor;
import ss2011.se.dp.visitors.SummarizeFileSizeVisitor;


public class HA7A1Test
{

	/**
	 * Teilaufgabe 1, siehe PDF
	 */
	@Test
	public void testFileFactoryAlone()
	{
		FilesystemFactory ff = new FilesystemFactory();
		
	
		// zuerst soll uns die FilesystemFactory ein Objekt als Stellvertreter fuer ein Directory (z.B. ".") anlegen
		AbstractFile f = null; // FIXME hier aendern: ff.create...(...?)
		assertNotNull(f);
		assertEquals(f.getClass(), Directory.class);
				
		// nun noch fuer ein RegularFile anlegen (muss nicht existieren)
		f = null; // FIXME hier aendern: ff.create...(...?)
		assertNotNull(f);
		assertEquals(f.getClass(), RegularFile.class);
	}
	
	/**
	 * Teilaufgabe 2:
	 * 
	 * Welche Vorteile bietet die Factory Klasse hier in diesem Fall konkret?
	 * mindestens 30 Worte und 2 Vorteile.
	 * 
	 * <Antwort hier!>
	 * 
	 */
	
	private Directory root;

   @Before
	public void init(){
       File start = new File(".");
       System.out.println("Running in: " + start.getAbsolutePath());
       root = new Directory(null, start);
		root.printTree();
	}

	@Test
	public void testCountAllFiles() {

		CountFilesVisitor visitor = new CountFilesVisitor();
		root.accept(visitor);
		System.out.println("Total number of Files: " + visitor.getCountedFiles());
		assertEquals(root.countAllFiles(), visitor.getCountedFiles());
	}
	
	@Test 
	public void testCountTotalFileSize() { 
		SummarizeFileSizeVisitor visitor = new SummarizeFileSizeVisitor();
		root.accept(visitor);
		System.out.println("Total size of all files: " + visitor.getTotalSize());
		assertEquals(root.countTotalFileSize(), visitor.getTotalSize());
	}
	
	@Test
	public void testCountClassFiles()
	{
		long num = root.countDotClass();
		RegularExpressionVisitor visitor = new RegularExpressionVisitor(".class");
		root.accept(visitor);
		System.out.println("Total number of .class-Files: " + visitor.getCountedFiles());
		assertEquals(num, visitor.getCountedFiles());
	}
	
	@Test
	public void testCountTotalDotJavaFileSize()
	{
		long num = root.countDotJavaSize();
		RegularExpressionVisitor visitor = new RegularExpressionVisitor(".java");
		root.accept(visitor);
		System.out.println("Total size of all .java-Files: " + visitor.getTotalSize());
		assertEquals(num, visitor.getTotalSize());
	}
	
}
