package ss2011.se.dp.filesystem;

import java.io.File;

import ss2011.se.dp.visitors.CountFilesVisitor;
import ss2011.se.dp.visitors.Visitor;

public abstract class Archive extends AbstractFile
{

    protected long compressedSize;

    public Archive(AbstractFile parent, File file)
    {
        super(parent, file.getName());
        this.compressedSize = file.length();
    }

    @Override
    public long getSize()
    {
        return compressedSize;
    }
    
    public void accept(Visitor visitor) {
    	
    	if(this.getChildren() != null) {
    		
    		for (AbstractFile f : this.getChildren())
            {
                f.accept(visitor);
            }
    	}
        	
    	visitor.visit(this);
    }
}
