package ss2011.se.dp.ha6_musterloesung;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;

import javax.swing.tree.TreeNode;

public class FileTreeNodeAdapter implements TreeNode {

	private File file;
	private TreeNode parent;
	private List<TreeNode> children;
	
	public FileTreeNodeAdapter(File file, FileTreeNodeAdapter parent) {
		this.file = file;
		this.parent = parent;
	}

	@Override
	public Enumeration<TreeNode> children() {
		readChildren();
		return Collections.enumeration(children);
	}

	@Override
	public boolean getAllowsChildren() {
		return file.isDirectory();
	}

	@Override
	public TreeNode getChildAt(int arg0) {
		readChildren();
		return children.get(arg0);
	}

	@Override
	public int getChildCount() {
		readChildren();
		return children.size();
	}

	@Override
	public int getIndex(TreeNode arg0) {
		readChildren();
		return children.indexOf(arg0);
	}

	@Override
	public TreeNode getParent() {
		return parent;
	}

	@Override
	public boolean isLeaf() {
		return !file.isDirectory();
	}

	@Override
	public String toString(){
		return file.getName();
	}
	
	private void readChildren(){
		if(children != null)
			return;
		
		children = new ArrayList<TreeNode>();
		System.out.println("Reading " + file);
		
		for(File f : file.listFiles())
		{
			children.add(new FileTreeNodeAdapter(f, this));			
		}
	}
}
