package ss2011.se.dp.ha6_musterloesung;

import java.io.PrintStream;
import java.text.DateFormat;
import java.util.Date;

/**
 * Time Decorator
 */
public class TimeDecoratorPrintStream extends PrintStream {

	/**
	 * Parent print stream
	 */
	private final PrintStream parentPrintStream;

	/**
	 * Print a text with a current time 
	 */
	@Override
	public void println(String x) {
		parentPrintStream.print(DateFormat.getTimeInstance().format(new Date()) + " ");
		parentPrintStream.println(x);
	}

	/**
	 * Constructor
	 */
	public TimeDecoratorPrintStream(PrintStream printStream) {
		super(printStream);
		parentPrintStream = printStream;		
	}

}
