package ss2011.se.dp.ha6_musterloesung.bonus;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.text.DateFormat;
import java.util.Date;

public class AusgabeServer extends Thread
{

	public static final int DEFAULT_PORT = 10865;

	private BufferedReader br;
	private Socket socket;

	private AusgabeServer(Socket socket) throws IOException
	{
		this.socket = socket;
		// we want to read single, newline-terminated lines, use BufferedReader for that
		br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
	}

	@Override
	public void run()
	{
		try
		{
			String line;
			while (socket.isConnected()
					// Thread will die silently if remote side ends the connection properly
					&& (line = br.readLine()) != null)
			{
				System.out.println(DateFormat.getTimeInstance().format(new Date()) + " " + socket.getRemoteSocketAddress() + " " + line);
			}
		} catch (IOException e)
		{
			throw new RuntimeException(e);
		}
	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException
	{
		// only one listening socket possible, so we do that in main() instantly...:
		ServerSocket s = new ServerSocket(DEFAULT_PORT);
		while (!Thread.interrupted())
		{
			Socket client = s.accept();
			System.out.println("Client " + client.getRemoteSocketAddress() + " connected.");
			// for each client connection, start an independent thread so multiple concurrent connections can be handled
			new AusgabeServer(client).start();
		}
	}

}
