package ss2011.se.dp.visitors;

import ss2011.se.dp.filesystem.Archive;
import ss2011.se.dp.filesystem.Directory;
import ss2011.se.dp.filesystem.RegularFile;

public class RegularExpressionVisitor implements Visitor{

	private String expression;
	private int countedFiles = 0;
	private long totalSize = 0;
	
	public RegularExpressionVisitor(String expression) {
		
		this.expression = expression;
		
	}
	
	@Override
	public void visit(RegularFile file) {
		if(file.getName().toLowerCase().endsWith(expression)) {
			countedFiles = countedFiles + 1;
			totalSize = totalSize + file.getSize();
		}
	}

	@Override
	public void visit(Archive file) {
		if(file.getName().toLowerCase().endsWith(expression)) {
			countedFiles = countedFiles + 1;
			totalSize = totalSize + file.getSize();
		}
	}

	@Override
	public void visit(Directory file) {
		if(file.getName().toLowerCase().endsWith(expression)) {
			countedFiles = countedFiles + 1;
			totalSize = totalSize + file.getSize();
		}
	}

	public int getCountedFiles() {
		return countedFiles;
	}

	public long getTotalSize() {
		return totalSize;
	}

}
